From f0520c2baf38aaafe1d6cd8052ae1bd08ef89544 Mon Sep 17 00:00:00 2001
From: Alister <alister.hood@synergine.com>
Date: Wed, 21 Sep 2011 10:22:22 +1200
Subject: [PATCH 4/4] fix minor typos

---
 resources/customization.xml                        |    2 +-
 src/core/raster/qgsrastertransparency.cpp          |    4 ++--
 .../databaseconnection/evisdatabaseconnection.cpp  |    4 ++--
 src/plugins/georeferencer/qgsgeorefplugingui.h     |    2 +-
 src/ui/qgsrasterlayerpropertiesbase.ui             |    2 +-
 5 files changed, 7 insertions(+), 7 deletions(-)

diff --git a/resources/customization.xml b/resources/customization.xml
index 618d4d6..872e29a 100644
--- a/resources/customization.xml
+++ b/resources/customization.xml
@@ -1935,7 +1935,7 @@
           <widget class="QLabel" label="&lt;p align=&quot;right&quot;&gt;Full&lt;/p&gt;" objectName="textLabel4"/>
         </widget>
         <widget class="QGroupBox" label="" objectName="gboxCustomTransparency">
-          <widget class="QLabel" label="Transparency band" objectName="lblTransarent"/>
+          <widget class="QLabel" label="Transparency band" objectName="lblTransparent"/>
           <widget class="QComboBox" label="" objectName="cboxTransparencyBand"/>
           <widget class="QLabel" label="Transparent pixel list" objectName="label_2"/>
         </widget>
diff --git a/src/core/raster/qgsrastertransparency.cpp b/src/core/raster/qgsrastertransparency.cpp
index dae0d84..cee9955 100644
--- a/src/core/raster/qgsrastertransparency.cpp
+++ b/src/core/raster/qgsrastertransparency.cpp
@@ -103,7 +103,7 @@ int QgsRasterTransparency::alphaValue( double theValue, int theGlobalTransparenc
     return 0;
   }
 
-  //Search through he transparency list looking for a match
+  //Search through the transparency list looking for a match
   bool myTransparentPixelFound = false;
   TransparentSingleValuePixel myTransparentPixel = {0, 100};
   for ( int myListRunner = 0; myListRunner < mTransparentSingleValuePixelList.count(); myListRunner++ )
@@ -141,7 +141,7 @@ int QgsRasterTransparency::alphaValue( double theRedValue, double theGreenValue,
     return 0;
   }
 
-  //Search through he transparency list looking for a match
+  //Search through the transparency list looking for a match
   bool myTransparentPixelFound = false;
   TransparentThreeValuePixel myTransparentPixel = {0, 0, 0, 100};
   for ( int myListRunner = 0; myListRunner < mTransparentThreeValuePixelList.count(); myListRunner++ )
diff --git a/src/plugins/evis/databaseconnection/evisdatabaseconnection.cpp b/src/plugins/evis/databaseconnection/evisdatabaseconnection.cpp
index c753463..f0f7a5e 100644
--- a/src/plugins/evis/databaseconnection/evisdatabaseconnection.cpp
+++ b/src/plugins/evis/databaseconnection/evisdatabaseconnection.cpp
@@ -34,7 +34,7 @@
 * @param port - The port number the database server is listening to
 * @param databasename - The name of the database to connect to
 * @param username - The username needed to access the database or database server
-* @param password - The password associate witht he username needed to access the database or database server
+* @param password - The password associate with the username needed to access the database or database server
 * @param type - The type of database being connected to
 */
 eVisDatabaseConnection::eVisDatabaseConnection( QString hostname, int port, QString databasename, QString username, QString password, DATABASE_TYPE type )
@@ -191,7 +191,7 @@ QSqlQuery* eVisDatabaseConnection::query( QString sqlStatement )
 * @param port - The port number the database server is listening to
 * @param databasename - The name of the database to connect to
 * @param username - The username needed to access the database or database server
-* @param password - The password associate witht he username needed to access the database or database server
+* @param password - The password associate with the username needed to access the database or database server
 * @param type - The type of database being connected to
 */
 void eVisDatabaseConnection::resetConnectionParameters( QString hostname, int port, QString databasename, QString username, QString password, DATABASE_TYPE type )
diff --git a/src/plugins/georeferencer/qgsgeorefplugingui.h b/src/plugins/georeferencer/qgsgeorefplugingui.h
index 76c39cd..6f65cb7 100644
--- a/src/plugins/georeferencer/qgsgeorefplugingui.h
+++ b/src/plugins/georeferencer/qgsgeorefplugingui.h
@@ -171,7 +171,7 @@ class QgsGeorefPluginGui : public QMainWindow, private Ui::QgsGeorefPluginGuiBas
     /**
      * Calculates root mean squared error for the currently active
      * ground control points and transform method.
-     * Note that he RMSE measure is adjusted for the degrees of freedom of the
+     * Note that the RMSE measure is adjusted for the degrees of freedom of the
      * used polynomial transform.
      * @param error out: the mean error
      * @return true in case of success
diff --git a/src/ui/qgsrasterlayerpropertiesbase.ui b/src/ui/qgsrasterlayerpropertiesbase.ui
index ee0d4ee..7fb6087 100644
--- a/src/ui/qgsrasterlayerpropertiesbase.ui
+++ b/src/ui/qgsrasterlayerpropertiesbase.ui
@@ -1021,7 +1021,7 @@
          </property>
          <layout class="QGridLayout">
           <item row="0" column="0">
-           <widget class="QLabel" name="lblTransarent">
+           <widget class="QLabel" name="lblTransparent">
             <property name="text">
              <string>Transparency band</string>
             </property>
-- 
1.7.4.msysgit.0